<template>
  <div class="container has-text-left pb-5">
    <p class="mb-3"><em>Testing utility that allows to send actual messages to other connectors/agents (or internal agents). This allows to quickly check whether a request is handled correctly and whether the policies are correctly setup, since these are real requests the OpenAPI Data App will perform policy negotiation if required.</em></p>
    <b-field label="Broker" horizontal>
      <div>
        <div>
          <b-button type="is-success" @click="brokerQuery">Query</b-button>
          <span class="control ml-4" v-if="brokerResult">
            <b-switch class="pt-2" v-model="searchable">Searchable</b-switch>
          </span>
        </div>
        <b-table
          v-if="brokerResult"
          :data="brokerResult"
          paginated
          per-page="20"
          detailed
          detail-key="id"
          default-sort="id"
          >
          <b-table-column field="id" label="Agent" :searchable="searchable" sortable v-slot="props">
            {{ props.row.id }} (<span style="max-width: 150px; text-overflow: ellipsis;">{{ props.row.agentTitle }}</span>)
          </b-table-column>
          <b-table-column field="connector" label="Connector" :searchable="searchable" sortable v-slot="props">
            {{ props.row.connector }} (<span style="max-width: 150px; text-overflow: ellipsis;">{{ props.row.connectorTitle }}</span>)
          </b-table-column>
          <template #detail="props">
            <b-field label="Agent ID" horizontal>{{ props.row.id }}</b-field>
            <b-field label="Agent Title" horizontal>{{ props.row.agentTitle }}</b-field>

            <b-field label="API Spec" horizontal>{{ props.row.apiSpec }}</b-field>
            <b-field label="Access URL" horizontal>{{ props.row.accessUrl }}</b-field>

            <b-field label="Connector ID" horizontal>{{ props.row.connector }}</b-field>
            <b-field label="Connector Title" horizontal>{{ props.row.connectorTitle }}</b-field>
            <b-field label="Connector Curator" horizontal>{{ props.row.curator }}</b-field>

            <b-field horizontal><b-button type="is-primary" @click="useAgent(props.row)">Use</b-button></b-field>
          </template>
        </b-table>
      </div>
    </b-field>
    <b-field label="Sender agent" horizontal>
      <b-select v-model="sender" placeholder="Select sender agent" expanded>
          <option
              v-for="agent in agents"
              :value="agent.id"
              :key="agent.id">
              {{ agent.title }} ({{ agent.id }})
          </option>
      </b-select>
    </b-field>
    <b-field label="Recipient agent" horizontal>
      <b-input v-model="recipient" required placeholder="Recipient agent ID" />
    </b-field>
    <b-field label="Version" horizontal>
      <b-input v-model="version" required placeholder="Version" />
    </b-field>
    <b-field label="Method" horizontal>
      <b-select v-model="method" placeholder="HTTP Method" expanded>
          <option
              v-for="method in methods"
              :value="method"
              :key="method">
              {{ method }}
          </option>
      </b-select>
    </b-field>
    <b-field label="Path" horizontal>
      <b-input v-model="path" required placeholder="Path" />
    </b-field>
    <b-field label="Headers" horizontal>
      <div>
        <b-field class="mb-2" v-for="(header, idx) in headers" :key="'header'+idx">
          
          <b-input v-model="headers[idx].name" @input="headerNameChange" placeholder="Key" />
          <b-input v-model="headers[idx].value" placeholder="Value" expanded />
          <p class="control">
            <b-button type="is-danger"
                icon-right="delete"
                :disabled="headers[idx].name === '' && idx === headers.length - 1"
                @click="() => { headers.splice(idx, 1) }" />
          </p>
        </b-field>
      </div>
    </b-field>
    <b-field label="Body" horizontal v-if="!['GET','HEAD','OPTIONS'].includes(method)">
      <div>
        <b-select v-model="contentType" placeholder="Content type (select common one, or provide via headers above)" expanded @input="contentTypeChange">
            <option>application/json</option>
            <option>application/xml</option>
            <option>text/plain</option>
            <option>application/ld+json</option>
        </b-select>
        <b-input v-model="body" type="textarea" class="textarea-monospace"></b-input>
      </div>
    </b-field>
    <b-field horizontal>
      <b-button type="is-success" @click="sendRequest">Send</b-button>
    </b-field>
    <div v-if="response">
      <h2 class="subtitle">Response</h2>
      <b-field label="URL" horizontal>{{ requestUrl }}</b-field>
      <b-field label="Request Headers" horizontal>
        <div>
          <b-field :label="name" v-for="(value, name) in requestHeaders" :key="'requestHeader'+name" horizontal>{{value}}</b-field>
        </div>
      </b-field>
      <b-field label="Status" horizontal>{{ response.status }} {{ statusCodes[response.status] }}</b-field>
      <b-field label="Duration" horizontal>{{ responseTime }}s</b-field>
      <b-field label="Response Headers" horizontal>
        <div>
          <b-field :label="name" v-for="(value, name) in response.headers" :key="'responseHeader'+name" horizontal>{{value}}</b-field>
        </div>
      </b-field>
      <b-field label="Body" horizontal><pre>{{response.data}}</pre></b-field>
    </div>
  </div>
</template>

<style >
.textarea-monospace > textarea {
  font-family: monospace;
}
</style>

<script lang="ts">
import { Component, Prop, Vue, Watch } from 'vue-property-decorator';
import axios, { AxiosRequestHeaders, AxiosResponse, Method } from 'axios';
import { AgentConfig, HTMLEvent } from '@/model';

@Component({})
export default class Tester extends Vue {
  agents: Array<AgentConfig> = []

  methods = ['GET', 'POST', 'PUT', 'PATCH', 'DELETE', 'HEAD', 'OPTIONS']

  sender: string | null = null
  recipient: string = ''
  version: string = ''
  method: string = 'GET'
  path: string = ''
  headers: [{
    name: string,
    value: string
  }] = [{
    name: '',
    value: ''
  }]
  contentType = null
  body: string = ''

  response: AxiosResponse | null = null
  responseTime: number = 0
  requestUrl: string = ''
  requestHeaders: AxiosRequestHeaders = {}

  searchable = false

  brokerResult: any = null
  
  private api = axios.create({
    baseURL: 'mgmt',
  });
  private openApi = axios.create({
    baseURL: 'openapi',
  });

  async created() {
    await Promise.all([
      this.getAgents()
    ]);
  }

  async getAgents() {
    const agents = await this.api.get('agents');
    this.agents = agents.data;
  }

  headerNameChange() {
    if (this.headers[this.headers.length-1].name != '') {
      this.headers.push({
        name: '',
        value: ''
      })
    }
  }

  contentTypeChange(contentType: string) {
    const contentTypeHeader = this.headers.find((header) => header.name.toLowerCase() === "content-type")
    if (contentTypeHeader) {
      contentTypeHeader.value = contentType
    } else {
      this.headers.unshift({
        name: 'Content-Type',
        value: contentType
      })
    }
  }

  useAgent(agent: any) {
    this.recipient = agent.id
    this.version = agent.apiSpec.split('/').pop()
    this.brokerResult = undefined
  }

  async sendRequest(event: HTMLEvent) {
    event.target?.classList.add("is-loading")
    this.requestHeaders = Object.fromEntries(
      this.headers
        .filter((header) => header.name.trim() !== '')
        .map((header) => [header.name, header.value]) as any
    )
    this.requestHeaders['Forward-ID'] = this.recipient
    this.requestHeaders['Forward-Sender'] = this.sender || ''

    const data = (!['GET','HEAD','OPTIONS'].includes(this.method)) ? this.body : undefined
    this.requestUrl = `/${this.version}/${this.path.replace(/^\//, '')}`
    const startTimer = Date.now()
    this.response = await this.openApi({
      method: this.method as Method,
      url: this.requestUrl,
      validateStatus: () => true,
      headers: this.requestHeaders,
      data: data
    });
    const endTimer = Date.now()
    
    this.responseTime = (endTimer - startTimer)/1000
    event.target?.classList.remove("is-loading")
  }

  async brokerQuery(event: HTMLEvent) {
    event.target?.classList.add("is-loading")
    const result = await this.openApi.post(`broker-sparql`,
      `PREFIX ids: <https://w3id.org/idsa/core/> DESCRIBE * WHERE {  GRAPH ?g { ?s ?o ?p.  }}`,
      {
        headers: {
          "Content-Type": "text/plain",
        },
      }
    );
      
    this.brokerResult = result.data.flatMap((connector: any) =>
      connector["ids:resourceCatalog"]?.flatMap((catalog: any) =>
        catalog["ids:offeredResource"]?.flatMap((resource: any) => {
          return {
            connector: connector["@id"],
            connectorTitle: connector["ids:title"]?.[0]?.["@value"],
            curator: connector["ids:curator"]?.["@id"],
            maintainer: connector["ids:maintainer"]?.["@id"],
            id: resource["ids:sovereign"]?.["@id"],
            agentTitle: resource["ids:title"]?.[0]?.["@value"],
            apiSpec: resource["ids:resourceEndpoint"]?.[0]?.["ids:endpointDocumentation"]?.[0]?.["@id"],
            accessUrl: resource["ids:resourceEndpoint"]?.[0]?.["ids:accessURL"]?.["@id"]
          };
        })
      )
    );

    event.target?.classList.remove("is-loading")
  }

  private statusCodes = {
    100: "Continue",
    101: "Switching Protocols",
    200: "OK",
    201: "Created",
    202: "Accepted",
    203: "Non-Authoritative Information",
    204: "No Content",
    205: "Reset Content",
    206: "Partial Content",
    300: "Multiple Choices",
    301: "Moved Permanently",
    302: "Found",
    303: "See Other",
    304: "Not Modified",
    305: "Use Proxy",
    306: "(Unused)",
    307: "Temporary Redirect",
    308: "Permanent Redirect",
    400: "Bad Request",
    401: "Unauthorized",
    402: "Payment Required",
    403: "Forbidden",
    404: "Not Found",
    405: "Method Not Allowed",
    406: "Not Acceptable",
    407: "Proxy Authentication Required",
    408: "Request Timeout",
    409: "Conflict",
    410: "Gone",
    411: "Length Required",
    412: "Precondition Failed",
    413: "Content Too Large",
    414: "URI Too Long",
    415: "Unsupported Media Type",
    416: "Range Not Satisfiable",
    417: "Expectation Failed",
    418: "(Unused)",
    421: "Misdirected Request",
    422: "Unprocessable Content",
    426: "Upgrade Required",
    500: "Internal Server Error",
    501: "Not Implemented",
    502: "Bad Gateway",
    503: "Service Unavailable",
    504: "Gateway Timeout",
    505: "HTTP Version Not Supported"
    }
}
</script>